\ AnaL.fth Taqoz V2.8
\ CWE 03.10.21

{   
    J: Cog 5 for vga display, pLcScale
    K: Automatic adcGain

}

IFDEF *DistAn*	
    6 cogstop 
    oldorg org
    FORGET *DistAn*  }


pub *DistAn*    PRINT" Distortion Analyzer AnaI.fth" ;

0 bytes oldorg

--- { Pins and Variables Buffers
8 := dacpin
14 := adcpin
57 := dLedPin

long ampl
32767 ampl !
long dangle
5.000.000 dangle !
long dacFreq
long adcGain \ 0..4
0 adcGain !
long gainPc \ per cent

long insight

4003 := aBufLen \ this is longs. First value is not valid
$6C000	:= aBuf

1 13 << := adcReso 
200.000.000 4096 / := adcSampleFreq

6 longs pltSet ( pltBusy dacFreq adcPP 3rd 2nd outampl )
long basemag 
long 2ndmag
long 3rdmag
long adcpp

1077.00 := dacCalib \ 32767 = 1077mV Vpp 

1644.00 := adcCalib \ 1644 = 1000mVpp

\ } Pins and Variables
  
--- { Sine Output ################################################################

{
: nextSine ( angle -- angle )
    ampl @ 0 3RD QROTATE 
    32767 + WYPIN DROP
    dangle @ +
;     

: sineout
    24 LOW
    \ dacpin PIN
    \ 1650 mV
    KEY DROP
    0
    BEGIN
        dacpin PIN nextSine
        24 PIN T \ toggle pin 24 128 kHz        
    KEY UNTIL
;

  
: sineTask
    24 LOW
    dacpin PIN
    1650 mV
    0
    BEGIN
        dacpin PIN nextSine
        24 PIN T \ toggle pin 24 128 kHz
    AGAIN
;

\ ' sineTask 6 RUN
}

{
: setfreq ( freqHz -- )
    5.000.000.00 28536 */ dangle !
;
}

{
code nextSineAsm ( d:ampladr c:dangleadr b:offset a:angle -- ampladr dangleadr offset angle )
    rdlong xx,c '\ get delta angle
    add a,xx '\ new angle
    rdlong xx,d '\ get amplitude
    qrotate xx,a
    getqy xx
    add xx,b '\ add offset
    wypin xx,#dacpin '\ output to pin 0
end   

code sineAsm ( -- ) 
    BEGIN:
        rdlong r0, #ampl '\ get amplitude
        qrotate r0,r1 '\ calculate sine
        rdlong r2, #dangle '\ get delta angle
        add r1,r2 '\ new angle      
        wrlong r1, #insight '\ write to insight-variable  
        outnot #24   '\ toggle pin 24 1.8 MHz       
        getqy r3 '\ get sine result
        add r3, ##32767 '\ add offset
        wypin r3,#dacpin '\ output to pin 0
    AGAIN: ' endless
end  
    
: sineAsmTask
    24 LOW \ set pin 24 output and low
    dacpin PIN
    1650 mV
    sineAsm
;

\ ' sineAsmTask 6 RUN
}

{
: setfreq ( freqHz -- )
    5.000.000.00 207908 */ dangle !
;
}


\ ------------------------------------------------------------------

code sineCogAsm ( d:ampladr c:dangleadr b:offset a:angle ) 
    rdlong r0, #ampl '\ get amplitude
    qrotate r0,r1 '\ calculate sine
    rdlong r2, #dangle '\ get delta angle
    add r1,r2 '\ new angle      
    wrlong r1, #insight '\ write to insight-variable  
    outnot #24   '\ toggle pin 24 2.5 MHz
    add r3, ##32767 '\ add offset
    wypin r3,#dacpin '\ output to pin 0    
    getqy r3 '\ get sine result
    jmp #\@COGMOD '\ endless FD80_01CB 
    ret '\ dummy, never reached
end 

   

\ https://forums.parallax.com/discussion/comment/1491355#Comment_1491355
: sineCogAsmTask
    24 LOW \ set pin 24 output and low
    dacpin PIN 
    1650 mV \ activate dac
    8 DAC \ not 12
    AT sineCogAsm 2+ 20 LOADMOD \ load the code into cog memory
    COGMOD \ execute the module
;

 ' sineCogAsmTask 6 RUN

{ 

\ this example for COGMOD works:
code test ( value n -- value+3*n 0 )
    add b,#3
    sub a,#1 wz
    if_nz jmp #\@COGMOD '\ loop from start
    ret
end

AT test 2+ 4 LOADMOD \ loads the asm instructions of test into cog ram
10 5 COGMOD . . \ executes any loaded code

}
{
long insight
long du1
7 du1 !

code test ( adr -- value )
    rdlong r1, a
    wrlong a, #insight '\ writes r1 to insight variable
    ret
end

AT test 2+ 6 LOADMOD
du1 COGMOD .
}

: .ins \ print insight
    KEY drop
    begin
        insight @ . SPACE
        100 ms
    KEY until
;
.ins    

{
: setfreq ( freqHz -- )
    dup dacFreq !
    5.000.000.00 291070 */ dangle !
;
}
\ 1000 setfreq

pub NDAC ( bits -- ) \ noise no pwm		
    %101_00_0_0000000_01_00010 WRFNC   |< WXPIN ;

{
: .cogs \ print the words running
    8 0 do
        crlf i . space i task w@ cfa>nfa .nfa
    loop
;
}


: setfreq ( freqHz -- )
    aBufLen adcSampleFreq */ 10 * 5 + \ bin
    adcSampleFreq aBufLen */ 10 /
    dup .
    dup dacFreq !
    5.000.000.00 291070 */ dangle !
;

: setOutpp ( mVpp -- ) \ set calibrated output mVpp
    32767.00 dacCalib */ ampl ! ;

\ } sineout

--- { Adc Input ##################################################################

\ 1000 setfreq

\ adcpin pin 50000 adc
\ adcpin rdpin .

{
\ 480v
\ -mac \ sw auf ws
-mono
vclr

40.000 := acycle

: oszi
    vclr
    adcpin pin acycle adc
    key drop
    begin
        \ 100 ms
        \ vclr
        begin \ trigger
        rdpin acycle 1 >> < until
        begin
        rdpin acycle 1 >> > until                
        600 0 do
            begin \ adc ready ?
            adcpin pin@ until
            white i rdpin 400 $FFFF */ plot
        loop
    key until
;
\ oszi
}    

\ pub ADC ( cycles -- )		%100_011_0000000_00_01111 WRFNC WXPIN 0 WYPIN ; \ mode passt nicht

{
: setSync2 ( ) \ P page 97 Sync2 2048 clocks, 12 bits
    asm:
    '\ wrpin ##%100011_0000000_00_11000_0,#adcpin '\ gain=1
    '\ wrpin ##%100100_0000000_00_11000_0,#adcpin '\ gain=3.16  
    '\ wrpin ##%100101_0000000_00_11000_0,#adcpin '\ gain=10 
    wrpin ##%100110_0000000_00_11000_0,#adcpin '\ gain=31.6     
    '\ wrpin ##%100111_0000000_00_11000_0,#adcpin '\ gain=100 
    wxpin #%01_1011,#adcpin '\ 1011 2048 clocks 1101 8192 clocks
    dirh #adcpin
    ' SETSE1 #%001<<6 + adcpin
    ret
end

dLedPin low

long adcval

: getSyncAdc
    setSync2
    adcpin pin
    0 
    begin 
        adcpin pin@ 0= if dLedPin high else dLedPin low then
        begin adcpin pin@ until \ adc ready ?
        rdpin dup 
        rot swap - adcval !
    again
;

\ ' getSyncAdc 7 RUN

: getAdcVal 
    adcval @ 6 >> 2047 and
;
}

\ } Adc Input

--- { Adc Sinc Filter Buffer Input ###############################################

{
: setSinc2 ( ) \ P page 97 Sync2 4096 clocks, 13 bits
    asm:
    '\ wrpin ##%100011_0000000_00_11000_0,#adcpin '\ gain=1
    '\ wrpin ##%100100_0000000_00_11000_0,#adcpin '\ gain=3.16  
    '\ wrpin ##%100101_0000000_00_11000_0,#adcpin '\ gain=10 
    wrpin ##%100110_0000000_00_11000_0,#adcpin '\ gain=31.6     
    '\ wrpin ##%100111_0000000_00_11000_0,#adcpin '\ gain=100 
    wxpin #%01_1100,#adcpin '\ 1100 4096 clocks
    dirh #adcpin
    ' SETSE1 #%001<<6 + adcpin
    ret
end


: fillSyncAdc
    setSinc2
    dLedPin low
    adcpin pin
    0 
    aBufLen 0 do 
        \ i . space
        adcpin pin@ 0= if dLedPin high 
        else dLedPin low then
        begin adcpin pin@ until \ adc ready ?
        rdpin dup 
        rot swap - 
        11 >> 
        8191 and 
        I 4* aBuf + !
    loop
    drop
    dLedPin low
;
}

\ } Sinc Filter Buffer Input

--- { Adc Sinc3 ##################################################################

{
: setSync3 ( ) \ P page 95 Sync3 128 clocks, 14 bits
    asm:
    wrpin ##%100011_0000000_00_11000_0,#adcpin
    wxpin #%10_0111,#adcpin
    dirh #adcpin
    ret
end
}

{
: setSync3 ( ) \ P page 95 Sync3 512 clocks, 18 bits
    asm:
    wrpin ##%100011_0000000_00_11000_0,#adcpin
    wxpin #%10_1001,#adcpin
    dirh #adcpin
    ret
end
}

\ see sinc3 in P2 docu v35 page 97

\ without trigger
{ 
: fillSync3Adc ( -- 0 1 2 3 ) \ 18 bit 512 clocks
    setSync3
    0 \ trigger flag and counter on stack: d
    aBuf \ Buffer address on stack: c
    aBufLen \ on stack: b
    1 6 << adcpin + \ for setse on stack: a
    \ .s
    ASM:
        '\ setse4 a '\ from tos
        mov r1,#0 '\ clear diff1
        mov r2,#0 '\ clear diff2
    .l1 testp #adcpin wc  '\ waitse4 '\ wait for sample period done
        if_nc jmp #l1
        rdpin r0,#adcpin '\ get SINC3 accumulator
        sub r0,r1 '\ compute sample
        add r1,r0 '\ update diff1 value
        sub r0,r2 '\ compute sample
        add r2,r0 '\ update diff2 value
        shr r0,#9 '\ #7 justify 14-bit sample
        zerox r0,#17 '\ #13 trim 14-bit sample
                        '\ use x here 'use sample somehow
        wrlong r0,c     '\ write to buffer
        add c,#4        '\ next address in buffer
        sub b,#1 wz     '\ one done
        if_nz jmp #l1  '\ loop for next period
        ret 
end
}

\ with djnz 
{ 
code fs3a ( d: stat c:aBuf b:len a:level -- d c b a )
    '\ setse4 a '\ from tos
    mov r1,#0 '\ clear diff1
    mov r2,#0 '\ clear diff2

.l0
.l1
.l2 testp #adcpin wc  '\ waitse4 '\ wait for sample period done
    if_nc jmp #l2
    rdpin r0,#adcpin '\ get SINC3 accumulator
    sub r0,r1 '\ compute sample
    add r1,r0 '\ update diff1 value
    sub r0,r2 '\ compute sample
    add r2,r0 '\ update diff2 value
    shr r0,#9 '\ #7 justify 14-bit sample
    zerox r0,#17 '\ #13 trim 14-bit sample, now use sample somehow
    
    '\ mov r3,#5
    '\ djnz r3,#l3

    cmp d,#2 wz     '\ stat 0: wait f minus, 1: w plus, 2: sample
    '\ if_z jmp #l4     '\ la2
    mov r3,#1
    if_z mov r3,#2
    djnz r3,#l4

    cmp d,#1 wz     '\ stat 0: wait f minus, 1: w plus, 2: sample
    '\ if_z jmp #l5     '\ la3
    mov r3,#1
    if_z mov r3,#2
    djnz r3,#l5
    
    cmp r0,a wc     '\ status is 0 - wait for minus
    if_c add d,#1   '\ new status 1+
    jmp #l0

.l5 cmp r0,a wc      '\ status is 1 - wait for plus
    if_nc mov d,#2   '\ new status 2   
    jmp #l1


.l3
.l4 wrlong r0,c     '\ sampling write to buffer
    add c,#4        '\ next address in buffer
    djnz b,#l2  '\ loop for next period
    ret 
end
}

\ with positive edge trigger, skip instruction
{ 
code fs3a ( d: stat c:aBuf b:len a:level -- d c b a )
    '\ setse4 a '\ from tos
    mov r1,#0 '\ clear diff1
    mov r2,#0 '\ clear diff2

.l0 testp #adcpin wc  '\ waitse4 '\ wait for sample period done
    if_nc jmp #l0
    rdpin r0,#adcpin '\ get SINC3 accumulator
    sub r0,r1 '\ compute sample
    add r1,r0 '\ update diff1 value
    sub r0,r2 '\ compute sample
    add r2,r0 '\ update diff2 value
    shr r0,#9 '\ #7 justify 14-bit sample
    zerox r0,#17 '\ #13 trim 14-bit sample, now use sample somehow

    '\ skip #%1111111111

    cmp d,#2 wz     '\ stat 0: wait f minus, 1: w plus, 2: sample
    if_z skip #%11111111    '\ Status is 2, sampling

    cmp d,#1 wz     '\ stat 0: wait f minus, 1: w plus, 2: sample
    if_z skip #%111         '\ Status is 1
    
    cmp r0,a wc     '\ status is 0 - wait for minus
    if_c add d,#1   '\ new status 1+
    jmp #l0

    cmp r0,a wc      '\ status is 1 - wait for plus
    if_nc mov d,#2   '\ new status 2   
    jmp #l0

    wrlong r0,c     '\ status is 2: sampling write to buffer
    add c,#4        '\ next address in buffer
    djnz b,#l0  '\ loop for next period
    ret 
end
}



\ with positive edge trigger, timeout, skip instruction
{
code fs3a ( d: status c:aBuf b:Buflen a:level -- d c b a )
    '\ setse4 a '\ from tos
    mov r1,#0       '\ clear diff1
    mov r2,#0       '\ clear diff2
    mov r3,##5000   '\ timeout number of samples

.l1 sub r3,#1 wz    '\ counter for timeout
    if_z mov d,#2
    
.l0 testp #adcpin wc  '\ waitse4 '\ wait for sample period done
    if_nc jmp #l0
    rdpin r0,#adcpin '\ get SINC3 accumulator
    sub r0,r1 '\ compute sample
    add r1,r0 '\ update diff1 value
    sub r0,r2 '\ compute sample
    add r2,r0 '\ update diff2 value
    shr r0,#9 '\ #7 justify 14-bit sample
    zerox r0,#17 '\ #13 trim 14-bit sample, now use sample somehow

    '\ skip #%1111111111

    cmp d,#2 wz     '\ stat 0: wait f minus, 1: w plus, 2: sample
    if_z skip #%11111111    '\ Status is 2, sampling

    cmp d,#1 wz     '\ stat 0: wait f minus, 1: w plus, 2: sample
    if_z skip #%111         '\ Status is 1
    
    cmp r0,a wc     '\ status is 0 - wait for minus
    if_c add d,#1   '\ new status 1+
    jmp #l1

    cmp r0,a wc      '\ status is 1 - wait for plus
    if_nc mov d,#2   '\ new status 2   
    jmp #l1

    wrlong r0,c     '\ status is 2: sampling write to buffer
    add c,#4        '\ next address in buffer
    djnz b,#l0  '\ loop for next period
    ret 
end



: fillSync3Adc ( -- 0 1 2 3 ) \ with trigger 18 bit 512 clocks
    setSync3
    -3 \ trigger status -3 on stack: d
    aBuf \ Buffer address on stack: c
    aBufLen \ on stack: b
    adcReso 2/ \ trigger level on stack: a
    fs3a
;


: fillS3AdcNoTrig ( -- 0 1 2 3 ) \ with trigger 18 bit 512 clocks
    setSync3
    2 \ trigger status -3 on stack: d
    aBuf \ Buffer address on stack: c
    aBufLen \ on stack: b
    adcReso 2/ \ trigger level on stack: a
    fs3a
;
}

\ }

--- { Sinc2 Sampling Mode ########################################################

\ Sinc Sample with fixed Gain
{ 
: setSincSample ( ) \ P page 97 Sync2 4048 clocks, 13 bits
    asm:
    dirl #adcpin    
    '\ wrpin ##%100011_0000000_00_11000_0,#adcpin '\ gain=1
    '\ wrpin ##%100100_0000000_00_11000_0,#adcpin '\ gain=3.16  
    '\ wrpin ##%100101_0000000_00_11000_0,#adcpin '\ gain=10 
    wrpin ##%100110_0000000_00_11000_0,#adcpin '\ gain=31.6     
    '\ wrpin ##%100111_0000000_00_11000_0,#adcpin '\ gain=100 
    wxpin #%00_1100,#adcpin '\ 1011 2048 clocks 1100 4096 clocks
    '\ wypin ##4095
    dirh #adcpin
    ' SETSE1 #%001<<6 + adcpin
    ret
end
}


\ P page 97 Sync2 4048 clocks, 13 bits
: setgain \ set gain factor for adc Sinc2 Sample Mode
    adcpin pin
    F \ dirl 
    adcGain @ 0 = if 
        %100011_0000000_00_11000_0 wrpin 100 gainPc ! 
    then
    adcGain @ 1 = if 
        %100100_0000000_00_11000_0 wrpin 316 gainPc !
    then    
    adcGain @ 2 = if 
        %100101_0000000_00_11000_0 wrpin 1000 gainPc !
    then    
    adcGain @ 3 = if 
        %100110_0000000_00_11000_0 wrpin 3160 gainPc !
    then    
    adcGain @ 4 = if 
        %100111_0000000_00_11000_0 wrpin 10000 gainPc !
    then    
    %00_1100 wxpin \ 1011 2048 clocks 1100 4096 clocks
    L \ dirh
;

: fillSincSample ( ) \ Fill buffer in 13 bit Sample Mode
    setgain
    dLedPin low
    adcpin pin
 
    aBufLen 0 do 
        \ i . space
        adcpin pin@ 0= if dLedPin high 
        else dLedPin low then
        begin adcpin pin@ until \ adc ready ?
        rdpin 
        I 4* aBuf + !
    loop
    dLedPin low
;

: getPP ( -- ) \ get and store peak peak
    fillSincSample
    0 100000
    aBufLen 2 do
        i 4* aBuf + @ dup >r
        mins swap
        r> maxs swap        
    loop
    - adcpp !
;

: fillAutoGain \ Fill buffer in 13 bit Sample Mode, automatic gain
    begin 
        begin 
            fillSincSample
            getPP
        adcpp @ 6700 >  adcGain @ 0 > and while
            -1 adcGain +!
        repeat
    adcpp @ 6000 3 / <  adcGain @ 4 <   and while
        1 adcGain +!
    repeat
;


\ } Sinc2 Sampling Mode
      
--- { Windowing ##########################################################

: window \ Bartlett 3-eck https://de.wikipedia.org/wiki/Fensterfunktion
    aBufLen 2/ 0 do
        i 4* aBuf + dup @ adcReso 2/ - 
        i aBufLen 2/ */
        swap !

        aBuf aBufLen 4* + i 4* - dup @ adcReso 2/ -
        i aBufLen 2/ */
        swap !        
    loop
;

\ } Windowing

: Goertzel_Library ; \ { ###################################################################

\ Goerzel    https://forum.micropython.org/viewtopic.php?t=7290
\ E.g. 200 samples at 10kHz sampling freq gives 50Hz bin width.
\ k = round(numSamples * target_freq / sampling_freq)
\     omega = 2.0 * math.pi * k / numSamples

long q0
long q1
long q2
long coeff

: omega ( targetfreq -- omega )
    1 31 << 1- 
    adcSampleFreq 1 >> 
    */
;

: sin1m ( omega -- sine*1.000)
    1 16 << 0 rot QROTATE swap drop ;

: cos1m ( omega -- cos*1.000)
    $4000.0000 + sin1m ;

\ Original with Variables
{
: goertzel ( targetfreq -- magnitude )
    q1 ~ 
    q2 ~
    omega cos1m 2 * coeff !
    aBufLen 1 do
        q1 @ coeff @ 1 15 << */ q2 @ - 
        i 4* aBuf + @ 7 << + q0 !
        q1 @ q2 !
        q0 @ q1 !
    loop
    q1 @ 
    q2 @ coeff @ 1 16 << */ -
    aBufLen 1- / abs
;
}

\ Goertzel Forth original
{ 
: goertzel ( targetfreq -- magnitude )
    omega cos1m 2 * coeff !
    0 0 ( q2 =0 q1 = 0 )
    aBufLen 2 do
        ( q2 q1 )
        dup ( q1 @ ) coeff @ 1 16 << */ 
        ( q2 q1 x )
        3RD ( q2 @ ) -
        ( q2 q1 x )
        i 4* aBuf + @  4 <<   + 
        ( q2 q1 x )
        \ q0 is tos ( q0 ! )
        rot \ q1 @ q2 ! q0 @ q1 ! 
        drop \ 
    loop
    ( q2 q1 )
    swap 
    ( q1 q2 )
    coeff @ 1 17 << */ -
    aBufLen 1- / abs
;
}

\ Forth Goertzel Loop
{ 
: goeLoop ( 0 0 -- q2 q1 )
    aBufLen 2 do
        ( q2 q1 )
        dup ( q1 @ ) coeff @ 1 16 << */ 
        ( q2 q1 x )
        3RD ( q2 @ ) -
        ( q2 q1 x )
        i 4* aBuf + @  4 <<   + 
        ( q2 q1 x )
        \ q0 is tos ( q0 ! )
        rot \ q1 @ q2 ! q0 @ q1 ! 
        drop \ 
    loop
;
}

\ Goertzel Forth
{
: goertzelF ( targetfreq -- magnitude )
    omega cos1m 2 * coeff !
    0 0 ( q2 =0 q1 = 0 )
    goeLoop
    ( q2 q1 )
    swap 
    ( q1 q2 )
    coeff @ 1 17 << */ -
    aBufLen 1- / abs
;
}

code goeLoopAsm ( d:q2,0 c:q1,0 b:bufferaddr a:length -- q2 q1 )
    rdlong r0,#coeff
    add b,#8            '\ skip first 2 longs

.l0 
    mov		r4,c        '\ aBufLen 2 do coeff @ 1 16 << */ 
    xor		r4,r0       '\ 32*16.16 signed scaled multiply
    abs		r2,c
    abs		r3,r0
    qmul r2,r3
    getqx r1            '\ lower
    getqy r2            '\ higher
    rolword r2,r1,#1    '\ get middle words in r2
    mov		r4,r4 wc
    negc	r2,r2

    sub r2,d            '\ ( q2 @ ) -
    rdlong r1,b         '\ i 4* aBuf + @  4 <<   + 
    shl r1,#4           '\ was #4
    add r2,r1
    mov d,c             '\ q1 @ q2 ! q0 @ q1 ! 
    mov c,r2

    add b,#4
    djnz a,#l0          '\ loop

    jmp #\@2DROP '\ drop bufferaddr and length
end

{ \ Goertzel Pasm real only
: goertzel ( targetfreq -- magnitude )
    omega cos1m 2 * coeff !
    0 0 aBuf aBufLen 2 - 
    goeLoopAsm ( d:q2=0 c:q1=0 b:bufferaddr a:length -- q2 q1 )
    ( q2 q1 )
    swap 
    ( q1 q2 )
    coeff @ 1 17 << */ -
    aBufLen 1- / abs
;
}

\ double add unsigned
code 2add ( d:d1hi c:d1low b:d2hi a:d2low -- double_sum )
    add d,b wc
    addx c,a 
    jmp #\@2DROP
end 


\ Goertzel Pasm real + imag
: goertzel ( targetfreq -- magnitude )
    omega 
    dup >r \ save omega 
    cos1m 2 * coeff !
    0 0 aBuf aBufLen 2 - 
    goeLoopAsm ( d:q2=0 c:q1=0 b:bufferaddr a:length -- q2 q1 )
    ( q2 q1 )
    swap 
    ( q1 q2 )
    dup >r \ save q2

    \ real:
    coeff @   1 17 <<   */   -
    aBufLen 2- / abs 
    dup UM* \ square in double
    
    \ imag:
    r>   r> 
    sin1m   1 16 <<   */ 
    aBufLen 2- / abs
    dup UM* \ square in double
    
    2add sqrt
;


\ 1000 lap goertzel lap . .lap  
\ buflen 4000, Forth: 4,468,400 cycles= 22,342,000ns @200MHz
\ Pasm:                 495,488 cycles=  2,477,440ns @200MHz
{
1000 lap goertzelF lap . .lap 
1000 lap goertzel lap . .lap 
}
\ } Goertzel


: VGA_Graphics ; \ { ###############################################################

\ 480v

\ -mac sw auf ws

8 BPP 360p !VGA 
VGA 'A' EMIT -mono emit;
vclr

: qscale ( val -- pos )
    0 sqrt 2/ 350 swap - ; 

long lxmin
long lxmax
long lymin
long lymax
long lcmin 5 lcmin !
long lcmax 500 lcmax !

: setLogXy ( xmin ymin xmax ymax )
        lymax ! lxmax ! lymin ! lxmin ! ;

20 20 20000 20000 setLogXy        

: lscaleOrig ( val -- pos )
    log 2 >>
    350 500.000 log 2 >> */ 
    350 swap -
    0 maxs 350 mins
;

: lxscaleori ( val -- pos )
    log 2 >>
    639 500.000 log 2 >> */ 
    0 maxs 639 mins
;

: lscale ( val -- pos )
    log 2 >> lymin @ log 2 >> -
    340 lymax @ log 2 >> lymin @ log 2 >> - */ 
    340 swap -
    0 maxs 340 mins
;

: lxscale ( val -- pos )
    log 2 >> lxmin @ log 2 >> -
    639 lxmax @ log 2 >> lxmin @ log 2 >> - */ 
    0 maxs 639 mins
;

: lcscale ( val -- 0..7 ) \ log color scale
    log 2 >> lcmin @ log 2 >> -
    7 lcmax @ log 2 >> lcmin @ log 2 >> - */ 
    0 maxs 7 mins
;

: pLcScale ( 0..7 -- value ) \ print color scale
    lcmax @ log 2 >>    lcmin @ log 2 >> - 
    7 */
    lcmin @ log 2 >> +
    2 << exp 
;



: ** ( n exp -- n**exp )
    dup if 
        1 swap ( n 1 exp )
        0 do
            over *
        loop 
        swap drop
    else
        drop drop 1
    then
;


: lhgrid
    639 w
    gray pen
    6 0 do
        10 I ** dup lymin @ > over lymax @ < and if 
            dup lscale 0 swap VXY vga . emit;
        else drop
        then
        10 1 do
            10 J ** I * lscale 
            dup y 0 > if hline then
        loop
    loop
;

: lvgrid
    359 h
    gray pen
    6 0 do
        10 I ** dup lxmin @ > over lxmax @ < and if 
            dup lxscale 340 VXY vga . emit; 
        else drop 
        then
        10 1 do
            10 J ** I * lxscale 
            dup x 0 > if vline then
        loop
    loop
;


: vgaInfoOszi
    white pen
    0 10 VXY
    VGA 
    ." Output mVpp: " ampl @ dacCalib 32767.00 */ . 
    ."   Output Frequency: " dacFreq @ .
    ."   adc Gain: " gainPc @ .AS" 5|\.##"
    ."   mVpp: " adcpp @ 10.00 gainPc @ */ 1000.00 adcCalib */ .AS" 5|\.#"
    emit;
;


: vgaInfoFft
    white pen
    0 10 VXY
    VGA 
    ." Amplitude: " ampl @ . 
    ."   Output Frequency: " dacFreq @ .
    ."   adc Gain: " adcGain @ .
    ."   mVpp: " adcpp @ 10.00 gainPc @ */ 1000.00 adcCalib */ .AS" 5|\.#"    
    300 350 VXY    
    ."   Frequency "
    emit;
;

: vgaInfoDisto
    white pen
    0 10 VXY
    VGA 
    ."   Frequency: " dacFreq @ .
    \ ."   adc Gain: " adcGain @ .
    300 350 VXY     
    ." Output mVpp "
    emit;
;

: rgpen ( red green )
    2dup 
    + 2 + 0 maxs 4/ 2 swap - 0 maxs >r \ blue
    7 min 2 <<  \ green
    swap 7 min 5 << + \ red
    r> + 
    pen
;

: 2colors \ print color scale to vga
    VGA
    8 0 do
        white pen crlf i pLcScale .AS" 4|\#.#% "
        8 0 do
            J I rgpen i .
        loop
    loop  
    emit;
;
 

\ } VGA Graphics



: Oszi_App ; \ { ###############################################################


long oldy

: oszi
    vclr
    key drop
    begin
        100 ms
        vclr
        vgaInfoOszi
        359 2 / oldy !
        \ fillSyncAdc
        \ fillSync3Adc 2drop 2drop
        \ fillSincSample
        fillAutoGain
        aBufLen 600 min 3 do
            i 4* aBuf + @ 359 adcReso */ 0 maxs 359 mins
            begin
                dup oldy @ > if oldy ++ 
                else oldy -- then
                white i oldy @ plot                
            dup oldy @ = until
            drop
        loop
    key until
;

: .buf
    %magenta %pen crlf ." ================================================" crlf
    %plain
    aBufLen 0 do
        \ i . 
        i 4* aBuf + @ . crlf
    loop
;

\ } Oszi_App

: FFT_App ; \ { ####################################################################

: dB ( n -- 20*log10 )
    log   20 10 log */ ;

: log2pc ( n -- 100*log2 )
    log 100 2 log */ ;

long anaFreq
 
: fft
    key drop
    vclr
    20 20 20000 20000 setLogXy 
    lhgrid
    lvgrid
    vgaInfoFft
    \ fillSync3Adc 2drop 2drop
    \ fillSincSample
    fillAutoGain
    window
    vgaInfoFft
    250 anaFreq ! \ 500 = 50 
    359 2 / oldy !
    begin 
        anaFreq @ 10 / goertzel lscale
        begin
            dup oldy @ > if oldy ++ 
            else oldy -- then
            red anaFreq @ 10 / lxscale oldy @ plot                
        dup oldy @ = until
        drop
        \ anaFreq @ 11220 10000 */ anaFreq ! \ 20 per decade
        \ anaFreq @ 10471 10000 */ anaFreq ! \ 50 per decade
        anaFreq @ 10233 10000 */ anaFreq ! \ 100 per decade
        key if 1.000.000 anaFreq ! then \ endit
    anaFreq @ 250.000 > until
;

.S 

\ } FFT_App

: Distortion_App ; \ { ##############################################################


: goeAvg ( freq --- avgMag ) \ +/- 6 Hz
    dup >r 6 - goertzel 
    r> dup >r  goertzel +
    r> 6 + goertzel +
    3 /
;

: (disto) \ print and plot results for disto
    dacFreq @ goeAvg dup basemag ! .
    dacFreq @ 2* goeAvg dup 2ndmag ! . 
    dacFreq @ 3 * goeAvg dup 3rdmag ! .  
    
    green ampl @ dacCalib 32767.00 */ lxscale basemag @ 100 gainPc @ */ lscale plot
    blue ampl @ dacCalib 32767.00 */ lxscale 2ndmag @ 1000 * basemag @ / dup . lscale plot
    red  ampl @ dacCalib 32767.00 */ lxscale 3rdmag @ 1000 * basemag @ / dup . lscale plot
;


: disto \ App varies amplitude
    key drop
    vclr
    2 1 2000 60000 setLogXy 
    lhgrid
    lvgrid
    crlf ." OutmVpp; mVpp; BasMag; 2ndMag; 3rdMag; 2ndPMille; 3rdPMille"
    5 setOutpp
    begin
        vgaInfoDisto
        ampl @ crlf dacCalib 32767.00 */ . \ 0 ... 36000
        5 ms \ wait
        \ fillS3AdcNoTrig 2drop 2drop \ window
        \ fillSync3Adc 2drop 2drop
        \ fillSincSample 
        fillAutoGain
        window
        \ adcGain @ . adcpp @ .
        adcpp @ 10.00 gainPc @ */ 1000.00 adcCalib */ .AS" 5|\.#"
        (disto)        
        ampl @ 10471 10000 */ 32767 mins ampl ! 
        key if 32767 ampl ! then 
    ampl @ 32760 > until
;

1000 setfreq
32767 ampl !

\ fillSyncAdc
\ .buf


: semi ." ;" ;

: .; ( value -- ) . ." ;" ; \ print for CSV

: vga2. ( n -- ) \ print 2 digits to vga
    dup 10 / 9 mins 0 maxs 48 + vemit
    10 // 48 + vemit
;


: dimplot \ pltSet ( pltBusy dacFreq adcPP 3rd 2nd outampl )
    
    pltSet 4 + @ lxscale 4 - 
    pltSet 8 + @ lscale 4 - VXY
    
    pltSet 12 + @ lcscale
    pltSet 16 + @ lcscale rgpen
    
    pltSet 20 + @ dB
    vga2.
    
    \ print scale
    625   pltSet 20 + @ lscale 4 - VXY
    white pen
    pltSet 20 + @ dB vga2.
    
    pltSet ~ \ reset busy
;

' dimplot value 'dimplot
.S

: actPlot \ activate plot for dimap
    \ pltSet ( pltBusy dacFreq adcPP 3rd 2nd outampl )
    dacFreq @ pltSet 4 + !  
    adcpp @ 10.00 gainPc @ */ 1000.00 adcCalib */ dup .AS" 5|\.#" 
    10 / pltSet 8 + ! 
    3rdmag @ 1000 * basemag @ / pltSet 12 + ! 
    2ndmag @ 1000 * basemag @ / pltSet 16 + ! 
    ampl @ dacCalib 32767.00 */ pltSet 20 + ! 
    
    \ lap
    begin pltSet @ not until \ check busy
    pltSet ~~
    'dimplot 5 run 
    \ dimplot
    \ lap crlf .lap 
;

80 bytes efxname$

: dimap \ App varies Amplitude and Frequency
    key drop
    !polls \ stop watch 
    pltSet ~ \ clear busy
    vclr
    5 9 20000 3000 setLogXy 
    lhgrid
    lvgrid
    0 0 VXY 2colors
    crlf
    crlf ." Effect-Name: "
    get$ efxname$ $! key drop
    white pen 
    300 5 vxy vga 
    efxname$ print$ ."     " date. time.
    250 350 VXY ."   Test Frequency "
    emit; 
    crlf date. time. 
    crlf ." Test_Vpp; Test_Freq; BasMag; 2ndMag; 3rdMag; adc_mVpp"
    10 setOutpp
    begin
        55 anaFreq !
        
        begin
            crlf ampl @ dacCalib 32767.00 */ .; anaFreq @ setfreq semi
            1 ms 
            
            \ fillSincSample 
            fillAutoGain
            window
            
            dacFreq @ goeAvg dup basemag ! 
            .;
            dacFreq @ 2* goeAvg dup 2ndmag ! 
            .; 
            dacFreq @ 3 * goeAvg dup 3rdmag ! 
            .;            
            
            actPlot

            anaFreq @ 11892 10000 */ anaFreq ! \ 4 per octave
            \ anaFreq @ 11220 10000 */ anaFreq ! \ 20 per decade
            key if exit then
        anaFreq @ 10.000 > until
        
        ampl @ 14125 10000 */ 32767 mins ampl !
        \ ampl @ 11892 10000 */ 32767 mins ampl !  
        \ ampl @ 10471 10000 */ 32767 mins ampl !    
        \ ampl @ 10772 10000 */ 32767 mins ampl !   
        key if 32767 ampl ! then
    ampl @ 32766 > until 
;    

\ } Distortion_App

€  