# -*- coding: utf-8 -*-
"""
Created on Mon Oct  4 13:03:57 2021

@author: ChWEb
"""

import easygui
import math
#import dateutil.parser
#from matplotlib import cbook
import matplotlib.pyplot as plt
import numpy as np

adcsplit= np.zeros((31,14)) # Fixed Number of points!
splitfreq= np.zeros((31))
def splitData():
    global data, adcsplit
    oldf= 0
    k= 0
    j= 0
    for i in range(0,len(data['adc_mVpp'])):
        if(data['Test_Freq'][i]<oldf):
            k=k+1
            j=0
        adcsplit[j,k]= data['adc_mVpp'][i]
        splitfreq[j]= data['Test_Freq'][i]
        j=j+1
        oldf= data['Test_Freq'][i]
        

datafile= easygui.fileopenbox()
#datafile= 'C:\\Users\\ChWEb\\Documents\\Programmieren\\P2\\TaV2_8\\DiMaps\\Ts-Drive.csv'
print('loading', datafile)

data = np.genfromtxt(
    datafile, delimiter=';', skip_header=2, names=True,
    dtype=None)
splitData()
#fig, ax = plt.subplots(figsize=[12,8])
fig, ax = plt.subplots(figsize=[9,6])
ax.set_title("..."+datafile[-22:])
ax.set_xlabel("Test Frequency in Hz")
ax.set_ylabel("Response mVpp")

#ax.scatter(x, y, c=color, s=scale, label=color,alpha=0.3, edgecolors='none')
#ax.plot(data['Test_Freq'], data['adc_mVpp'], 'k.')
ax.plot(splitfreq, adcsplit, 'k:')
pos= ax.scatter(data['Test_Freq'], data['adc_mVpp'],
           s=np.log10((data['2ndMag']+data['3rdMag'])/data['BasMag']*150)**2*100,
           c=(data['2ndMag']-data['3rdMag'])/(data['2ndMag']+data['3rdMag'])*100,
           marker='s',
           cmap='RdYlGn',vmin=-100,vmax=100,
           edgecolors={'black'})
ax.set_xscale('log')
ax.set_yscale('log')
ax.axis([20,10000,8,4000])
ax.grid(which='both')   

   
cobar=fig.colorbar(pos,ax=ax) 
cobar.set_label('Red: 3rd Harmonics   --   Green: 2nd Harmomics')    
#fig.figtext(0.5,0.5)


# produce a legend with a cross section of sizes from the scatter
handles, labels = pos.legend_elements(prop="sizes", 
                                      num=[0.5, 1, 2, 5, 10, 20, 50],
                                      func= lambda s: (10**np.sqrt(s/100))/1.5,
                                      alpha=0.7,
                                      fmt="{x:2.0f}%",)
legend2 = ax.legend(handles, labels, loc="upper right", title="2nd+3rd Harm. Dist.")

ax.text(21, 1100, 'Test: mVpp', fontsize=12)
for i in range(0,14):
    test_pp= data['Test_Vpp'][i*31]
    ax.annotate(test_pp,
                xy=(54, data['adc_mVpp'][i*31]),
                xytext=(25, data['Test_Vpp'][i*31]),
                arrowprops=dict(facecolor='grey', 
                                shrink=0.05, 
                                width=2,
                                headwidth=5)
                )


fig.savefig(datafile.replace(".csv",".png"))
plt.show()